;Wormy      Dec. 01. 99

James_Rubingh
;james@acz.org
;http://james.acz.org

Scott_Noveck
;scott@acz.org
;http://scott.acz.org

 .nolist
  #include "ion2.inc"   ;replace this with ion.inc if that's what you use
 .list
#ifdef TI83P
	.org	progstart-2
	.db	$BB,$6D
#else
	.org	progstart
#endif
        xor a
	jr	nc,start
Description:
        .db  "Willy Wonder Worm",0

start:

 bcall(_grbufclr)

 ld hl,plotsscreen
 ld a,-1
 ld bc,23
 push bc
 call Fill
 ld hl,plotsscreen+744
 pop bc
 call Fill
 ld hl,history
 ld bc,767
 call Fill


DrawSides:
 ld hl,plotsscreen+(2*12)
 ld de,11
 ld b,60
dsloop:
 ld (hl),%11000000
 add hl,de
 ld (hl),%00000011
 inc hl
 djnz dsloop 

 call BuildTrigTables

 ld hl,$1000
 ld (X),hl
 ld (Y),hl
 xor a
 ld (direction),a
 ld (score),a
 ld hl,11
 ld (length),hl

 call Newpizza

main:
 ld b,6
wait:
 ld a,%01111100
 out (1),a
 in a,(1)

 bit 6,a
  ret z
 bit 2,a
  call z,rights
 bit 1,a
  call z,lefts

 djnz wait

 ld hl,history+765
 ld de,history+767
 ld bc,766
 lddr                           ;shift all history

 call MoveHead 
 call CheckCrash

 ld hl,(length)
 add hl,hl
 ld de,history
 add hl,de
 ld c,(hl)
 inc hl
 ld b,(hl)
 ld a,b
 inc a
 jr z,DontErase

  call ClearPixels

DontErase:
 ld a,(Y+1)
 ld c,a
 ld (history),a
 inc hl
 ld a,(X+1)
 ld b,a
 ld (history+1),a

 ld hl,(X)
  ld b,h
 ld hl,(Y)
  ld c,h
 call SetPixels

 bcall(_grbufcpy)


 halt
 halt
 halt
 jp main 

rights:
 ld hl,direction
 inc (hl)
 ret
lefts:
 ld hl,direction
 dec (hl)
 ret

ClearPixels:
   ld e,02
DE1: 
   push bc
   ld d,02
DE2:
   call ClearPixel
   inc b
   dec d
   jr nz,DE2
   pop bc
   inc c
   dec e
   jr nz,DE1
   ret

CheckCrash:
  ld a,(Y+1)
  ld hl,history
  cp (hl)
  jr nz,CheckIt

  ld a,(X+1)
  inc hl
  cp (hl)
  ret z

CheckIt:

  ld e,2
  ld a,(X+1)
  ld b,a
  ld a,(Y+1)
  ld c,a
  call CheckPixel
  inc b
  call CheckPixel
  inc c
  call CheckPixel
  dec b
  call CheckPixel
  bit 7,e
  ret z

dead:			;check if hit pea
  ld a,(X+1)
  ld b,a
  ld a,(px)
  sub b
  add a,3
  sub 7
  jr nc,dead2
  ld a,(Y+1)
  ld b,a
  ld a,(py)
  sub b
  add a,3
  sub 7
  jr nc,dead2
			;player hit pea
  ld a,(px)		;clear pea
  ld b,a
  ld a,(py)
  ld c,a
  call ClearPixels

  ld hl,(length)         ;increase length
  ld bc,9
  add hl,bc
  ld (length),hl
  ld a,(score)		;increase score
  inc a
  cp 33
  jr nz,goon
    jp dead2
goon:
  ld (score),a


  call NewPizza
  ret

dead2:
  pop hl

  bcall(_clrlcdf)
  ld a,(score)
  ld l,a
  ld h,0
  ld b,2
  ld de,ScoreText
convertscoretotext:
  bcall(_divhlby10)
  add a,48
  ld (de),a
  dec de
  djnz convertscoretotext

  ld hl,Done
  ld de,$0202
  ld (curRow),de
  bcall(_puts)
  bcall(_getcsc)
  bcall(_getkey)
  ret

Newpizza:
 ld a,r
 srl a
 srl a
 cp 46
 jr c,NP_flop
   ld d,a
   ld a,64
   sub d
NP_flop:
 add a,a
 ld b,a
 ld a,r
 srl a
 srl a
 ld c,a
  call CheckPixel
  jr nz,NewPizza
  inc b
  call CheckPixel
  jr nz,NewPizza
  inc c
  call CheckPixel
  jr nz,NewPizza
  dec b
  call CheckPixel
  jr nz,NewPizza
 ld hl,px
 ld (hl),b
 inc hl
 ld (hl),c
 jp SetPixels

MoveHead:
 ld a,(direction)
 ld b,a
 ld a,64
 sub b
 ld hl,SinCosTable
 add a,l
 ld l,a
 adc a,h
 sub l
 ld h,a
 ld c,(hl)              ;get decimal
 call extendBC
 ld hl,(X)
 add hl,bc
 add hl,bc
 ld (X),hl

 ld a,(direction)
 ld hl,SinCosTable
 add a,l
 ld l,a
 adc a,h
 sub l
 ld h,a
 ld c,(hl)              ;get decimal
 call extendBC
 ld hl,(Y)
 add hl,bc
 add hl,bc
 ld (Y),hl
 ret

SetPixels:
 ld e,02
SP1:
 push bc
 ld d,02
SP2:
 call SetPixel
 inc b
 dec d
 jr nz,SP2
 pop bc
 inc c
 dec e
 jr nz,SP1
 ret

SetPixel:		;draw 4 pixels
 push bc
 call FindPixel
 or (hl)
 ld (hl),a
 pop bc
 ret 

ClearPixel:
 push bc
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 pop bc
 ret

CheckPixel:
 push bc
 call FindPixel
 and (hl)
 pop bc
 ret z
 dec e
 ret

extendBC:
 ld b,0
 bit 7,c
 ret z
 ld b,255
 ret

Fill:
 ld e,l
 ld d,h
 inc de
 ld (hl),a
 ldir
 ret

FindPixel:
 push de
 ld a,c
 add a,a
 add a,a
 ld e,a
 ld d,0
 ld l,a
 ld h,d
 ld a,b
 rr a
 add hl,de
 rr a
 add hl,de
 rr a
 add a,l
 ld l,a
 adc a,h
 sub l
 ld h,a
 ld a,b
 and 7
 ld de,offsets
 add a,e
 ld e,a
 adc a,d
 sub e
 ld d,a
 ld a,(de)
 ld de,plotsscreen
 add hl,de
 pop de
 ret
offsets:
 .db 128,64,32,16,8,4,2,1

#include Trigtab.asm    ;sine table data

;aliases!
;----------

#ifdef	TI83P
history = appbackupscreen
#else
history = saferam2
#endif

SinCosTable = saferam1

X = op1
Y = op1+2
direction = op1+4
length = op1+5
score = op1+7   ;byte
py = op1+10
px = op1+9
level = op1+11

Done:
  .db "Score: ",0,0,0
ScoreText = $ - 2

.end
